<?php
// vim: foldmethod=marker
/**
 *  Ethna_Plugin_Validator_Select.php
 *
 *  @author     ICHII Takashi <ichii386@schweetheart.jp>
 *  @license    http://www.opensource.org/licenses/bsd-license.php The BSD License
 *  @package    Ethna
 *  @version    $Id: Ethna_Plugin_Validator_Select.php,v 1.3 2006/08/03 03:38:59 ichii386 Exp $
 */

// {{{ Ethna_Plugin_Validator_Select
/**
 *  쥯ȥեɥåץ饰
 *
 *  @author     ICHII Takashi <ichii386@schweetheart.jp>
 *  @access     public
 *  @package    Ethna
 */
class Ethna_Plugin_Validator_Select extends Ethna_Plugin_Validator
{
    /** @var    bool    뤫ե饰 */
    var $accept_array = false;

    /**
     *  쥯ȥեɤΥåԤ
     *
     *  @access public
     *  @param  string  $name       ե̾
     *  @param  mixed   $var        ե
     *  @param  array   $params     ץ饰Υѥ᡼
     */
    function &validate($name, $var, $params)
    {
        list($manager_key, $manager_attr) = $params;
        
        if ($manager_key == "") {
            $method = sprintf('list%s', str_replace('_', '', $manager_attr));
            $list = $this->af->$method();
            $r = empty($list[$var]) ? null : $list[$var];
        } else {
            $manager =& $this->backend->getManager($manager_key);
            $r = $manager->getAttrName($manager_attr, $var);
        }
        if (is_null($r)) {
            if (isset($params['error'])) {
                $msg = $params['error'];
            } else {
                $msg = "{form}ͤϤƤ";
            }
            return Ethna::raiseNotice($msg, E_FORM_INVALIDVALUE, array($params['select']));
        }

        return true;
    }
}
// }}}
?>
