<?php
/**
 *	Journal/Month.php
 *
 *	@author		Masaki Fujimoto
 *	@package	Flare
 *	@version	$Id: skel.action.php,v 1.8 2006/07/10 13:47:33 fujimoto Exp $
 */

include_once('Flare_Journal.php');
include_once('Flare_Tag.php');

/**
 *	journal_monthեμ
 *
 *	@author		Masaki Fujimoto
 *	@access		public
 *	@package	Flare
 */
class Flare_Form_JournalMonth extends Flare_ActionForm
{
    /** @var    bool    Хǡ˥ץ饰Ȥե饰 */
    var $use_validator_plugin = true;

    /** @var    array   ץꥱ󥪥֥(helper) */
    var $helper_app_object = array();

    /** @var    array   ץꥱ󥪥֥(helper)Ѥʤե̾ */
    var $helper_skip_form = array();

	/**
	 *	@access	private
	 *	@var	array	ե
	 */
	var	$form = array(
        'month' => array(
            'required' => true,
            'regexp' => '/^\d{4}-\d{2}$/',
            'type' => VAR_TYPE_STRING,
        ),
	);
}

/**
 *	journal_monthμ
 *
 *	@author		Masaki Fujimoto
 *	@access		public
 *	@package	Flare
 */
class Flare_Action_JournalMonth extends Flare_ActionClass
{
	/**
	 *	journal_month
	 *
	 *	@access	public
	 *	@return	string		̾(ｪλʤnull, λʤfalse)
	 */
	function prepare()
	{
        if ($this->af->validate() > 0) {
            return 'index';
        }
		return null;
	}

	/**
	 *	journal_monthμ
	 *
	 *	@access	public
	 *	@return	string	̾
	 */
	function perform()
	{
        $date_from = sprintf('%s-01', $this->af->get('month'));
        $t = strtotime($date_from);
        $date_to = strftime('%Y-%m-%d', strtotime(strftime('%Y/%m/01', $t+60*60*24*32)) - 60*60);

        $jm =& $this->backend->getManager('journal');
        list($journal_sum, $journal_list) = $jm->getJournalList(
            $this->session->get('user_id'),
            '',
            $date_from,
            $date_to,
            '',
            'journal.mtime',
            1,
            0,
            ''
        );
        $this->af->setApp('journal_list', $journal_list);
        $this->af->setApp('journal_sum', $journal_sum);

		return 'journal_month';
	}
}
?>
