<?php
/**
 *	User/Config/Do.php
 *
 *	@author		Masaki Fujimoto
 *	@package	Flare
 *	@version	$Id: skel.action.php,v 1.8 2006/07/10 13:47:33 fujimoto Exp $
 */

/**
 *	user_config_doեμ
 *
 *	@author		Masaki Fujimoto
 *	@access		public
 *	@package	Flare
 */
class Flare_Form_UserConfigDo extends Flare_ActionForm
{
    /** @var    bool    Хǡ˥ץ饰Ȥե饰 */
    var $use_validator_plugin = true;

    /** @var    array   ץꥱ󥪥֥(helper) */
    var $helper_app_object = array(
        'user' => null,
    );

    /** @var    array   ץꥱ󥪥֥(helper)Ѥʤե̾ */
    var $helper_skip_form = array('user_id', 'hash', 'ctime', 'mtime', 'state', 'type');

	/**
	 *	@access	private
	 *	@var	array	ե
	 */
	var	$form = array(
        'password' => array(
            'required' => false,
        ),
        'password_conf' => array(
            'required' => false,
        ),
        'config' => array(
            'name' => '',
            'form_type' => FORM_TYPE_SUBMIT,
        ),
	);
}

/**
 *	user_config_doμ
 *
 *	@author		Masaki Fujimoto
 *	@access		public
 *	@package	Flare
 */
class Flare_Action_UserConfigDo extends Flare_ActionClass
{
	/**
	 *	user_config_do
	 *
	 *	@access	public
	 *	@return	string		̾(ｪλʤnull, λʤfalse)
	 */
	function prepare()
	{
        if ($this->af->get('password') != "" || $this->af->get('password_conf') != "") {
            foreach (array('password', 'password_conf') as $key) {
                $def = $this->af->getDef($key);
                $def['required'] = true;
                $def = $this->af->setDef($key, $def);
            }
        }
        if ($this->af->validate() > 0) {
            return 'user_config';
        }
		return null;
	}

	/**
	 *	user_config_doμ
	 *
	 *	@access	public
	 *	@return	string	̾
	 */
	function perform()
	{
        $user =& $this->backend->getObject('user', 'user_id', $this->session->get('user_id'));
        $user->importForm(OBJECT_IMPORT_IGNORE_NULL);
        $user->update();

        $this->session->set('user', $user->getNameObject());

        $location = sprintf('Location: %s', $this->config->get('url'));
        header($location);
        return null;
	}
}
?>
