<?php
/**
 *	Mail.php
 *
 *	@author		Masaki Fujimoto
 *	@package	Flare
 *	@version	$Id: skel.action_cli.php,v 1.2 2006/07/10 13:47:33 fujimoto Exp $
 */

include_once('mimedecode.php');
include_once('Flare_Account.php');
include_once('Flare_Journal.php');
include_once('Flare_Tag.php');

/**
 *	mailեμ
 *
 *	@author		Masaki Fujimoto
 *	@access		public
 *	@package	Flare
 */
class Flare_Cli_Form_Mail extends Ethna_ActionForm
{
    /** @var    bool    Хǡ˥ץ饰Ȥե饰 */
    var $use_validator_plugin = true;

	/**
	 *	@access	private
	 *	@var	array	ե
	 */
	var	$form = array(
		/*
		'sample' => array(
            // ե
			'type'          => VAR_TYPE_INT,	// ͷ
			'form_type'     => FORM_TYPE_TEXT,	// ե෿
			'name'			=> 'ץ',		// ɽ̾

            // Хǡ(ҽ˥Хǡ¹Ԥޤ)
			'required'      => true,			// ɬܥץ(true/false)
			'min'           => null,			// Ǿ
			'max'           => null,			// 
			'regexp'        => null,			// ʸ(ɽ)

            // ե륿
			'filter'        => null,			// Ѵե륿ץ
		),
		*/
	);
}

/**
 *	mailμ
 *
 *	@author		Masaki Fujimoto
 *	@access		public
 *	@package	Flare
 */
class Flare_Cli_Action_Mail extends Ethna_ActionClass
{
	/**
	 *	mail
	 *
	 *	@access	public
	 *	@return	string		̾(ｪλʤnull, λʤfalse)
	 */
	function prepare()
	{
		return null;
	}

	/**
	 *	mailμ
	 *
	 *	@access	public
	 *	@return	string	̾
	 */
	function perform()
	{
        // ɸϸƤӹ
        $s = file('php://stdin');
        $stdin = implode('', $s);

        // MIMEǥ
        $mimedecoder = new MIMEDECODE($stdin, "\r\n");
        $contents = $mimedecoder->get_diary_data();

        $header = $contents['header'];
        $to = isset($header['x-original-to']) ? $header['x-original-to']: $header['to'];
        if (($pos = strpos($to, '<')) !== flase && $dust = strstr($to, '>')) {
            $to = substr($to, $pos + 1);
            $to = str_replace($dust, '', $to);
        }

        $subject = array_key_exists('subject', $header) ? $header['subject'] : '';
        $subject = mb_decode_mimeheader($subject);
        if ($subject == "") {
            $subject = "no subject";
        }

        if (preg_match('/^flare\+(\w{8})_(\w{8})@nx.eth.jp$/', $to, $match) == 0) {
            return null;
        }
        $am =& $this->backend->getManager('account');
        list($user_id, $account_id) = $am->getIdFromHash($match[2], $match[1]);

        $body = $contents['diary'];
        $list = preg_split("/\r?\n/", $body);
        $inout = array_shift($list);
        $tag_list = $list;
        $tag = implode(" ", $tag_list);
        $tag = mb_convert_encoding($tag, 'EUC-JP', 'ISO-2022-JP');

        // ɲý
        if ($inout{0} == '+') {
            $inout = substr($inout, 1);
        } else {
            $inout = "-$inout";
        }

        $journal =& $this->backend->getObject('journal');
        $journal->set('inout', $inout);
        $journal->set('user_id', $user_id);
        $journal->set('account_id', $account_id);
        $journal->set('name', $subject);
        $journal->set('ctime', strftime('%Y/%m/%d %H:%M:%S'));
        $journal->add();
        $journal_id = $journal->get('id');

        // 
        $tm =& $this->backend->getManager('tag');
        $tm->add($tag, $journal_id);

        return null;
	}
}
?>
