<?php
/**
 *  Flare_Controller.php
 *
 *  @author     Masaki Fujimoto
 *  @package    Flare
 *  @version    $Id: app.controller.php,v 1.19 2006/08/23 13:22:31 fujimoto Exp $
 */

/** ץꥱ١ǥ쥯ȥ */
define('BASE', dirname(dirname(__FILE__)));

// include_path(ץꥱǥ쥯ȥɲ)
$app = BASE . "/app";
$lib = BASE . "/lib";
ini_set('include_path', ini_get('include_path') . PATH_SEPARATOR . implode(PATH_SEPARATOR, array($app, $lib)));


/** ץꥱ饤֥Υ󥯥롼 */
include_once('Ethna/Ethna.php');
include_once('Flare_Error.php');
include_once('Flare_ActionClass.php');
include_once('Flare_ActionForm.php');
include_once('Flare_ViewClass.php');

/**
 *  FlareץꥱΥȥ
 *
 *  @author     Masaki Fujimoto
 *  @access     public
 *  @package    Flare
 */
class Flare_Controller extends Ethna_Controller
{
    /**#@+
     *  @access private
     */

    /**
     *  @var    string  ץꥱID
     */
    var $appid = 'FLARE';

    /**
     *  @var    array   forward
     */
    var $forward = array(
        /*
         *  TODO: forward򵭽ҤƤ
         *
         *  㡧
         *
         *  'index'         => array(
         *      'view_name' => 'Flare_View_Index',
         *  ),
         */
    );

    /**
     *  @var    array   action
     */
    var $action = array(
        /*
         *  TODO: action򵭽ҤƤ
         *
         *  㡧
         *
         *  'index'     => array(),
         */
    );

    /**
     *  @var    array   soap action
     */
    var $soap_action = array(
        /*
         *  TODO: SOAPץꥱѤaction
         *  ҤƤ
         *  㡧
         *
         *  'sample'            => array(),
         */
    );

    /**
     *  @var    array       ץꥱǥ쥯ȥ
     */
    var $directory = array(
        'action'        => 'app/action',
        'action_cli'    => 'app/action_cli',
        'action_xmlrpc' => 'app/action_xmlrpc',
        'app'           => 'app',
        'plugin'        => 'app/plugin',
        'bin'           => 'bin',
        'etc'           => 'etc',
        'filter'        => 'app/filter',
        'locale'        => 'locale',
        'log'           => 'log',
        'plugins'       => array(),
        'template'      => 'template',
        'template_c'    => 'tmp',
        'tmp'           => 'tmp',
        'view'          => 'app/view',
    );

    /**
     *  @var    array       DB
     */
    var $db = array(
        ''              => DB_TYPE_RW,
    );

    /**
     *  @var    array       ĥ
     */
    var $ext = array(
        'php'           => 'php',
        'tpl'           => 'tpl',
    );

    /**
     *  @var    array   饹
     */
    var $class = array(
        /*
         *  TODO: ꥯ饹饹SQL饹򥪡С饤
         *  ϲΥ饹̾˺줺ѹƤ
         */
        'class'         => 'Ethna_ClassFactory',
        'backend'       => 'Ethna_Backend',
        'config'        => 'Ethna_Config',
        'db'            => 'Ethna_DB_PEAR',
        'error'         => 'Ethna_ActionError',
        'form'          => 'Flare_ActionForm',
        'i18n'          => 'Ethna_I18N',
        'logger'        => 'Ethna_Logger',
        'plugin'        => 'Ethna_Plugin',
        'session'       => 'Ethna_Session',
        'sql'           => 'Flare_AppSQL',
        'view'          => 'Flare_ViewClass',
        'renderer'      => 'Ethna_Renderer_Smarty',
        'url_handler'   => 'Flare_UrlHandler',
    );

    /**
     *  @var    array       оݤȤʤץ饰ΥץꥱIDΥꥹ
     */
    var $plugin_search_appids = array(
        /*
         *  ץ饰󸡺˸оݤȤʤ륢ץꥱIDΥꥹȤ򵭽Ҥޤ
         *
         *  㡧
         *  Common_Plugin_Foo_Bar Τ褦̿̾Υץ饰󤬥ץꥱ
         *  ץ饰ǥ쥯ȥ¸ߤ硢ʲΤ褦˻ꤹ
         *  Common_Plugin_Foo_Bar, Flare_Plugin_Foo_Bar, Ethna_Plugin_Foo_Bar
         *  ν˥ץ饰󤬸ޤ 
         *
         *  'Common', 'Flare', 'Ethna',
         */
        'Flare', 'Ethna',
    );

    /**
     *  @var    array       ե륿
     */
    var $filter = array(
        /*
         *  TODO: ե륿ѤϤˤΥץ饰̾
         *  ҤƤ
         *  (饹̾ꤹfilterǥ쥯ȥ꤫ե륿饹
         *  ɤ߹ߤޤ)
         *
         *  㡧
         *
         *  'ExecutionTime',
         */
    );

    /**
     *  @var    array   ޥ͡
     */
    var $manager = array(
        /*
         *  TODO: ˥ץꥱΥޥ͡㥪֥Ȱ
         *  ҤƤ
         *
         *  㡧
         *
         *  'um'    => 'User',
         */
        'am' => 'Account',
        'jm' => 'Journal',
        'tm' => 'Tag',
    );

    /**
     *  @var    array   smarty modifier
     */
    var $smarty_modifier_plugin = array(
        /*
         *  TODO: ˥桼smarty modifier򵭽ҤƤ
         *
         *  㡧
         *
         *  'smarty_modifier_foo_bar',
         */
    );

    /**
     *  @var    array   smarty function
     */
    var $smarty_function_plugin = array(
        /*
         *  TODO: ˥桼smarty function򵭽ҤƤ
         *
         *  㡧
         *
         *  'smarty_function_foo_bar',
         */
    );

    /**
     *  @var    array   smarty prefilter
     */
    var $smarty_prefilter_plugin = array(
        /*
         *  TODO: ˥桼smarty prefilter򵭽ҤƤ
         *
         *  㡧
         *
         *  'smarty_prefilter_foo_bar',
         */
    );

    /**
     *  @var    array   smarty postfilter
     */
    var $smarty_postfilter_plugin = array(
        /*
         *  TODO: ˥桼smarty postfilter򵭽ҤƤ
         *
         *  㡧
         *
         *  'smarty_postfilter_foo_bar',
         */
    );

    /**
     *  @var    array   smarty outputfilter
     */
    var $smarty_outputfilter_plugin = array(
        /*
         *  TODO: ˥桼smarty outputfilter򵭽ҤƤ
         *
         *  㡧
         *
         *  'smarty_outputfilter_foo_bar',
         */
    );

    /**#@-*/

    /**
     *  ܻΥǥեȥޥꤹ
     *
     *  @access protected
     *  @param  object  Ethna_Renderer  饪֥
     *  @obsolete
     */
    function _setDefaultTemplateEngine(&$renderer)
    {
        // ǽǤХӥ塼δ쥯饹ѤƤ
    }
}
?>
